package cn.ibizlab.core.rule.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.core.rule.domain.ExecResult;
import cn.ibizlab.core.rule.filter.ExecResultSearchContext;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[ExecResult] 服务对象接口
 */
public interface IExecResultService extends IService<ExecResult> {

    boolean create(ExecResult et);
    void createBatch(List<ExecResult> list);
    boolean update(ExecResult et);
    void updateBatch(List<ExecResult> list);
    boolean remove(String key);
    void removeBatch(Collection<String> idList);
    ExecResult get(String key);
    ExecResult getDraft(ExecResult et);
    boolean checkKey(ExecResult et);
    ExecResult deleteAsync(ExecResult et);
    boolean deleteAsyncBatch(List<ExecResult> etList);
    boolean save(ExecResult et);
    void saveBatch(List<ExecResult> list);
    ExecResult saveAsync(ExecResult et);
    boolean saveAsyncBatch(List<ExecResult> etList);
    Page<ExecResult> searchDefault(ExecResultSearchContext context);
    List<ExecResult> selectByRuleId(String rule_id);
    void removeByRuleId(String rule_id);
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


